


$forms_menu->command( -label => '@mail', -command => \&Forms::mail );

sub Forms::mail
{
    my $mw = $mw->Toplevel( -title => '@mail' );

	my $F = $mw->Frame;
    my $f = $F->Frame;
	my $f1 = $F->Frame;
	$f->Label( -text => 'To' )->pack( );
	my $to = $f1->Entry(-class => 'UI' )->pack(  -fill => 'x', -expand=>1, -padx => 10, anchor => 'w' );

	$f->Label( -text => 'Subject' )->pack( );
	my $subject = $f1->Entry(-class => 'UI' )->pack(  -fill => 'x', -expand=>1, -padx => 10 );
	$f->pack( -side => 'left',  );
	$f1->pack( -expand => 1, -fill => 'x', -side => 'top');
	$F->pack( -expand => 1, -fill => 'x' );

    my $t = $mw->Scrolled( 'Text', -wrap => 'word', -class => 'UI',
                            -height => 15,  -width => 50 , -scrollbars => 'e'
                        )->pack(  -expand => 1, -fill => 'both' );
    $t->bind( '<Alt-s>', \&ispell );
    $f = $mw->Frame( );
    $b = $f->Button( -text => 'import text...',  -command => sub
            {
                    my $file = $file_select->Show() or return;
                    open FILE, $file
                        or ymusk_message( "Can't open $file: $!" ) and return;
                    $t->insert( 'end', $_ ) while <FILE>;
            }
    )->pack( -side => 'left' );
    my $c = $f->Button( -text => 'send', -command => sub{
            my $to = $to->get;
			my $subject = $subject->get;
            my $text = $t->get( '1.0', 'end' );
            $text =~ s/\n[\n\s]*\n/%r%r/g;
            $text =~ s/\n/ /g;
            &send( '@mail '. $to . ' = '. $subject . '/(to: ' . $to . ")%r%r" . $text . "\n" );
            $mw->destroy;
    }
    )->pack( -side => 'left', -padx => 10 );
    $f->pack( -anchor => 'e'  );
}

$forms_menu->command( -label => 'page', -command => \&Forms::page );
sub Forms::page
{
    my $mw = $mw->Toplevel( -title => 'page' );

    my $f = $mw->Frame;
	$f->Label( -text => 'To' )->pack( -side=> 'left' );
	my $to = $f->Entry(-class => 'UI' )->pack(  -fill => 'x', -expand=>1, -padx => 10, anchor => 'w' );
	$to->insert( '1.0', join ' ', @_ );
	$f->pack( -fill => 'x', -expand => 1 );

    my $t = $mw->Scrolled( 'Text', -wrap => 'word', -class => 'UI',
                            -height => 15,  -width => 50 , -scrollbars => 'e'
                        )->pack(  -expand => 1, -fill => 'both' );
    $t->bind( '<Alt-s>', \&ispell );
    $f = $mw->Frame( );
    $b = $f->Button( -text => 'import text...',  -command => sub
            {
                    my $file = $file_select->Show() or return;
                    open FILE, $file
                        or ymusk_message( "Can't open $file: $!" ) and return;
                    $t->insert( 'end', $_ ) while <FILE>;
            }
    )->pack( -side => 'left' );
    my $c = $f->Button( -text => 'send', -command => sub{
            my $to = $to->get;
            my $text = $t->get( '1.0', 'end' );
            $text =~ s/\n[\n\s]*\n/%r%r/g;
            $text =~ s/\n/ /g;
            &send( 'page '. $to . ' = ' . $text . "\n" );
            $mw->destroy;
    }
    )->pack( -side => 'left', -padx => 10 );
    $f->pack( -anchor => 'e'  );
}

$forms_menu->command( -label => 'general form', -command => \&Form::general );


sub Form::general
{
	my $mw = $mw->Toplevel( -title => 'Edit' );

	my $t = $mw->Scrolled( 'Text', -wrap => 'word', -class => 'UI',
			            	-height => 15,  -width => 50 , -scrollbars => 'e'
						)->pack( -expand => 1, -fill => 'both' );
	$t->bind( '<Alt-s>', \&ispell );
	my $f = $mw->Frame(  );
			$f->Label( -text => 'command' ,  )->pack( -side => 'left' );
	my $l = $f->Entry(  -class => 'UI'  )->pack( -side => 'left', -fill => 'x', -expand=>1,
									-padx => 10 );
	$f->pack( -expand => 1, -fill => 'x' );
	$f = $mw->Frame( );
	$b = $f->Button( -text => 'import text...',  -command => sub
			{
					my $file = $file_select->Show() or return;
					open FILE, $file 
						or ymusk_message( "Can't open $file: $!" ) and return;
					$t->insert( 'end', $_ ) while <FILE>;
			}
	)->pack( -side => 'left' );
	my $c = $f->Button( -text => 'send', -command => sub{
			my $command = $l->get;
			my $text = $t->get( '1.0', 'end' );
			$text =~ s/\n[\n\s]*\n/%r%r/g;
			$text =~ s/\n/ /g;
			&send( $command . $text . "\n" );
			$mw->destroy;
	}
	)->pack( -side => 'left', -padx => 10 );
	$f->pack( -anchor => 'e'  );
}

$forms_menu->command( -label => 'song', -command => \&Forms::song );

sub Forms::song
{
    my $mw = $mw->Toplevel( -title => 'song' );

    my $t = $mw->Scrolled( 'Text', -wrap => 'word', -class => 'UI',
                            -height => 15,  -width => 50 , -scrollbars => 'e'
                        )->pack(  -expand => 1, -fill => 'both' );
    $t->bind( '<Alt-s>', \&ispell );

	my $F = $mw->Frame;
    my $f = $F->Frame;
	my $f1 = $F->Frame;
	$f->Label( -text => 'prefix' )->pack( );
	my $prefix = $f1->Entry(-class => 'UI' )->pack(  -fill => 'x', -expand=>1, -padx => 10, anchor => 'w' );

	$f->Label( -text => 'delay' )->pack( );
	my $delay = $f1->Entry(-class => 'UI' )->pack(  -fill => 'x', -expand=>1, -padx => 10 );
	$f->pack( -side => 'left',  );
	$f1->pack( -expand => 1, -fill => 'x', -side => 'top');
	$F->pack( -expand => 1, -fill => 'x' );

    $f = $mw->Frame( );
    $b = $f->Button( -text => 'import text...',  -command => sub
            {
                    my $file = $file_select->Show() or return;
                    open FILE, $file
                        or ymusk_message( "Can't open $file: $!" ) and return;
                    $t->insert( 'end', $_ ) while <FILE>;
            }
    )->pack( -side => 'left' );

	my $c;
    $c = $f->Button( -text => 'play', -command => sub{
			my $status = $c->cget( '-text' );
			if( $status eq 'play' )
			{
				$c->configure( -text => 'stop' );
				Forms::play( $c, $t, $delay, $prefix );
			}
			else
			{
				$c->configure( -text => 'play' );
			}
    }
    )->pack( -side => 'left', -padx => 10 );
    $f->pack( -anchor => 'e'  );
}

sub Forms::play
{ 
	my ( $button, $t, $delay, $prefix ) = @_; 

	return if $button->cget( '-text' ) eq 'play';

	my $text = $t->get( '1.0', '1.0 lineend' );
	$t->delete( '1.0', '2.0' );
	$text =~ s/\n/ /g;

	# to fix :P
	# $button->configure( -text => 'play' ) if $t->index( 'end' ) <= 2 and $text =~ /^\s*$/;

	&send( $prefix->get() . " $text\n" ) if length $text;
	$mw->after( ( ( 0 + $delay->get() ) || 5 ) *1000, sub{ Forms::play( $button, $t, $delay, $prefix ) } );
}



'end of Forms.pm';
