
sub Notepad::open 
{
	my $mw = $mw->Toplevel( -title => 'Notepad' );

	my $text = $mw->Scrolled( 'Text', -wrap => 'word', -class => 'UI',
                            -height => 15,  -width => 50 , -scrollbars => 'e'
                        )->pack(  -expand => 1, -fill => 'both' );

	$mw->Button( -text    => 'close', 
	             -command => sub{ Notepad::close( $text, $mw ) } 
			   )->pack( -side => right );

	if( open NOTES, "$ymuskdir/notes" )
	{
        while( <NOTES> )
		{
			$text->insert( 'end', $_ );
		}
        close NOTES;
	}
}

sub Notepad::close
{
	my( $text, $mw ) = @_;
	open NOTES, ">$ymuskdir/notes" 
   	     or ymusk_message( "can't save notes: $!" ) and return;

	print NOTES $text->get( '1.0', 'end' );
	close NOTES;

	$mw->destroy;  
}


1;
