#! /usr/bin/perl -p

s/\e.*?m//g;

__END__

=pod

=head1 NAME

y_deansi.pl - remove ANSI escape characters from a file

=head1 SYNOPSIS

B<y_deansi.pl> I<infile> > I<outfile>

=head1 DESCRIPTION

B<y_deansi.pl> removes ANSI escape characters --
string of the form <ESC>[I<number>;I<number>;I<..>m --
from a file. 

=head1 NOTES

Now quite useless for ymusk, as it save its logs either
in plain text or in html. But I keep this utility here,
just in case.


